#
#!/bin/bash
#

# Image recovery CD or DVD for MyPC
# Hard disk should contain a NTFS partition followed by a FAT32 partition
# This script checks for the presence of these partitions and prints out some info for the user
# Then offers a menu to re-install Windows onto the NTFS partition only or
# erase all partitions, re-partition and reinstall Windows
#
# The Windows OS image was originally made by using partimage
# the MBR was made using dd
#
# The Windows OS image sda1.gz.000 is in the root of the CD/USB stick
# The MBR sector (file=mbr_shrt) is also in the root of the CD/USB
#
# Special hidden key + will exit this script to shell
#
# On boot - Finnix will mount the CDROM or USB drive as \cdrom, so all files are accessible


clear
echo "Loading - please wait..."
# wait for USB to be detected
sleep 2
clear
echo "Loading - please wait..."
# wait for USB to be detected
sleep 2
clear
echo "Loading - please wait..."
# wait for USB to be detected
sleep 6
legal=""

while [ "$legal" == "" ]
do

# LOOP UNTIL a legal command letter is input by user

clear
action=""
echo ""
echo "Image Recovery for MyPC"
echo "======================="
echo ""
echo "WARNING: This utility will destroy all"
echo "         user files on the hard disk."
echo
echo "         Use at your own risk!"
echo ""
# Deterimine if NTFS ptn on HDD
fdisk -l /dev/sda > bb
grep -i "NTFS" bb > nul
if [ $? == 0 ]; then
  NTFS="Y"
  echo "C: NTFS  partition exists"
fi
# Determine if FAT32 ptn on HDD
grep -i "FAT32" bb > nul
if [ $? == 0 ]; then
  FAT32="Y"
  echo "D: FAT32 partition exists"
fi
grep -i "133120000" bb > nul
if [ $? == 0 ]; then
  NTFS="Y"
  echo "Windows partition already exists."
else
  echo "WARNING: Windows partition may be incorrect size - use 'w' option."
fi
echo ""

#echo $FAT32 $NTFS
if [ "$NTFS$FAT32" == "YY" ]; then 
  install="C"
  echo "Found existing NTFS (C:) and FAT32 (D:) partitions on hard disk."
  echo ""
  echo "NOTE: the 'y' option is recommended."
else
  install="FULL"
  echo "Cannot find correct partitions on hard disk"
  echo "or partitions not correct size."
  echo ""
  echo "NOTE: The 'w' option is recommended."
fi

echo ""
echo ""
echo ""
echo "===================== MENU ======================"
echo ""
if [ "$install" == "C" ]; then
echo "  y = Re-install Windows on C: (D: is preserved)"
fi
#if [ "$install" == "FULL" ]; then
echo "  w = WIPE WHOLE DISK and re-install Windows"
#fi
echo "  r = Reboot"
echo ""
echo "================================================="
echo ""
echo -n "Select a letter: "
read -n 1 action
echo

if [ "$action" == "+" ]; then
  exit 0
fi
if [ "$action" == "Y" ]; then
  action=y
fi
if [ "$action" == "W" ]; then
 action=w
fi
if [ "$action" == "R" ]; then
 action=r
fi


if [ "$action" == "w" ]; then
	legal="Y"
fi
if [ "$action" == "y" ]; then
	legal="Y"
fi
if [ "$action" == "r" ]; then
	legal="Y"
fi
if [ "$action$install" == "wC" ]; then
	#legal=""
	#echo "Command is not legal"
	#action=""
        echo ""
fi

if [ "$legal" == "Y" ]; then
	echo ""
else
	legal=""
	echo ""
fi


# must be w y or r


clear
echo ""

if [ "$action" == "w" ]; then
	echo "Wiping hard disk and re-installing"
	echo -n "Are you sure (y/n) : "
	read -n 1 x
	if [ $x == "y" ]; then
	  echo ""
	  echo ""
		echo "Starting wipe and re-install:"
		# change action so ntfs is installed next
		action="y"
		echo writing partition table...
		dd if=/dev/zero of=/dev/sda bs=512 count=63 2> nul
		sleep 2
		dd if=/cdrom/mbr_shrt of=/dev/sda 2> nul
		# force fs to load new ptns
		sleep 2
		parted /dev/sda toggle 1 boot > nul
		parted /dev/sda toggle 1 boot > nul
		sleep 2
		echo Formatting D: partition
		mkfs -t vfat -F 32 /dev/sda2		
		sleep 2
		mkfs -t vfat -F 32 /dev/sda2
		# 
	    else
		action="" 
	fi
 fi


if [ "$action" == "y" ]; then
  echo ""
	echo "Now installing image to drive C:"
	echo ""
	echo Formatting C:
	# overwrite mbr code 
	dd if=/cdrom/mbr_shrt of=/dev/sda bs=440 count=1  2> nul
	mkfs -t ntfs -f /dev/sda1 > nul
	echo Restoring image to C: volume
	sleep 5
	partimage -b restore /dev/sda1 /cdrom/sda1.gz.000
  	clear
  	echo ""
	echo "Finished restore."
	action="r"
fi


if [ "$action" == "r" ]; then
	echo
	echo "PLEASE NOTE:"
	echo "Do NOT disconnect the USB boot device until the reboot countdown begins."
	echo ""
	echo -n "Press a key to reboot now : "
	read -n 1 ff
	clear
	echo
	echo "Rebooting..."
	echo
	echo "Wait for 10 second reboot countdown before disconnecting the USB boot device."
	echo "USB Flash memory pens may be corrupted if you do not wait."
	echo
	reboot
	sleep 100
fi

action=""
legal=""

done

echo "END OF SCRIPT /cdrom/finnix/finnix.sh"




